*******************************************************************************
* PROGRAMA: Demo ON PAINT event
* LENGUAJE: HMG
* FECHA:    Setiembre 2012
* AUTOR:    Dr. CLAUDIO SOTO
* PAIS:     URUGUAY
* E-MAIL:   srvet@adinet.com.uy
* BLOG:     http://srvet.blogspot.com
*******************************************************************************

***************************************************
*
* Bos Taurus CLONE demo
* 
* Sligthly modified version of (BosTaurus) Demo01
*
***************************************************

#include "hmg.ch"
#include "hfcl.ch"

FUNCTION MAIN

PRIVATE hBitmap := 0 

     DEFINE WINDOW Win1;
            AT 0,0;
            WIDTH  700;
            HEIGHT 600;
            TITLE "Bos Taurus: Clone Demo";
            MAIN;
            ON INIT     Proc_ON_INIT ();
            ON RELEASE  Proc_ON_RELEASE ();
            ON PAINT    Proc_ON_PAINT ()
        
            @  500, 280 BUTTON Button_1 ;
                        CAPTION "Click" ;
                        ACTION MsgInfo (BT_InfoName() + Space(3) + ;
                                        BT_InfoVersion() + CRLF + ;
                                        BT_InfoAuthor (), "Info")

    END WINDOW

    CENTER WINDOW Win1
    ACTIVATE WINDOW Win1
RETURN Nil


PROCEDURE Proc_ON_INIT

  LOCAL cBMFileName := GetFile(,, GetCurrentFolder() ),;
        nPBMWidth,;          // Width of partial bitmap
        nPBMHeight,;         // Height of partial bitmap
        hPBitMap             // Handle of partaial bitmap
        
  IF !EMPTY( cBMFileName )
     hBitmap := BT_BitmapLoadFile( cBMFileName )
  ENDIF
  
  nPBMWidth  := BT_BitmapWidth( hBitmap )  / 2
  nPBMHeight := BT_BitmapHeight( hBitmap ) 
  
  hPBitMap := BT_BitmapClone( hBitmap, 0, 0, nPBMWidth, nPBMHeight )
  
  BT_BitmapRelease( hBitmap )
  
  hBitmap := hPBitMap
  
RETURN


PROCEDURE Proc_ON_RELEASE
   BT_BitmapRelease (hBitmap)
RETURN


PROCEDURE Proc_ON_PAINT

LOCAL hDC, BTstruct

   hDC := BT_CreateDC ("Win1", BT_HDC_INVALIDCLIENTAREA, @BTstruct)
   BT_DrawGradientFillVertical (hDC, 0, 0, BT_ClientAreaWidth("Win1"), ;
                                           BT_ClientAreaHeight("Win1"), ;
                                           WHITE, BLACK)
   BT_DrawBitmap (hDC, 30, 150, 400, 400, BT_COPY, hBitmap)
   BT_DeleteDC (BTstruct)
   
RETURN


